Index: /extensions/GrumPluginClasses/classes/GPCCategorySelector.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCCategorySelector.class.inc.php	(revision 7175)
+++ /extensions/GrumPluginClasses/classes/GPCCategorySelector.class.inc.php	(revision 7175)
@@ -0,0 +1,434 @@
+<?php
+/**
+ * -----------------------------------------------------------------------------
+ * class name     : GPCCategorySelector
+ * class version  : 1.0.0
+ * plugin version : 3.3.0
+ * date           : 2010-10-09
+ * -----------------------------------------------------------------------------
+ * author: grum at piwigo.org
+ * << May the Little SpaceFrog be with you >>
+ * -----------------------------------------------------------------------------
+ *
+ * :: HISTORY
+ *
+| release | date       |
+| 1.0.0   | 2010/04/18 | * create class
+|         |            |
+|         |            |
+|         |            |
+|         |            |
+|         |            |
+|         |            |
+|         |            |
+|         |            |
+ *
+ *
+ * -----------------------------------------------------------------------------
+ *
+ *  this class provides methods to easily insert a hierarchical categories
+ *  selector in the HTML pages
+ *
+ * -----------------------------------------------------------------------------
+ *
+ * Const
+ *  - GPCCategorySelector::FILTER_ALL
+ *  - GPCCategorySelector::FILTER_ACCESSIBLE
+ *  - GPCCategorySelector::FILTER_PUBLIC
+ *  there is no filter 'private only' or 'not accessible only' because these
+ *  kind of categories are probably sub categories of 'public' categories
+ *
+ *
+ * Methods
+ *  - public __construct($options)
+ *  - public __destruct()
+ *  - public setFilter($filter)
+ *  - public getFilter()
+ *  - public setGalleryRoot($galleryRoot)
+ *  - public getGalleryRoot()
+ *  - public getCategoryList()
+ *
+ *
+ * -----------------------------------------------------------------------------
+ *
+ */
+
+
+class GPCCategorySelector
+{
+  const FILTER_ALL            = 'all';         // no filter, all categories are listed
+  const FILTER_ACCESSIBLE     = 'accessible'; // only accessible categories are listed (public + private with some access right)
+  const FILTER_PUBLIC         = 'public';     // only public categories are listed
+
+  const USER_MODE_ADMIN       = 'admin';      // returns result without user acces right applied (admin can see everything...)
+  const USER_MODE_PUBLIC      = 'public';     // returns result with user acces right applied
+
+
+  private $options=array(
+    'filter'      => self::FILTER_ACCESSIBLE,
+    'galleryRoot' => true,
+    'tree'        => false,
+    'userMode'    => self::USER_MODE_PUBLIC,
+  );
+
+
+  /**
+   * constructor for the object
+   *
+   * all options are facultative
+   *
+   * @param Array $options : an array with the options
+   *               String 'filter'      : can take one the defined FILTER values
+   *               Bool   'galleryRoot' : if set to true, the category list
+   *                                      contain at root, an item with id = 0
+   *                                      and named 'all the gallery'
+   *               Bool   'tree'        : if set to true, the category list
+   *                                      is returned as a tree, otherwise result
+   *                                      is returned as a flat array
+   *               String 'userMode'    : 'admin' returns result without user
+   *                                      right access applied ; 'public' returns
+   *                                      result with user right acces applied
+   */
+  public function __construct($options=array())
+  {
+    if(isset($options['filter'])) $this->setFilter($options['filter']);
+    if(isset($options['galleryRoot'])) $this->setGalleryRoot($options['galleryRoot']);
+    if(isset($options['tree'])) $this->setTree($options['tree']);
+    if(isset($options['userMode'])) $this->setUserMode($options['userMode']);
+  }
+
+  /**
+   * destructor dor the object
+   */
+  public function __destruct()
+  {
+    unset($this->options);
+  }
+
+  /**
+   * set the filter value to apply on the categories
+   *
+   * @param String $filer : the filter value
+   * @return String : the filter value
+   */
+  public function setFilter($filter)
+  {
+    if($filter==self::FILTER_ALL or
+       $filter==self::FILTER_ACCESSIBLE or
+       $filter==self::FILTER_PUBLIC) $this->options['filter']=$filter;
+
+    if($this->options['userMode']==self::USER_MODE_PUBLIC and
+       !($this->options['filter']==self::FILTER_ACCESSIBLE or $this->options['filter']==self::FILTER_PUBLIC)) $this->options['filter']==self::FILTER_ACCESSIBLE;
+
+    return($this->options['filter']);
+  }
+
+  /**
+   * get the filter value affected on the categories
+   *
+   * @return String : the filter
+   */
+  public function getFilter()
+  {
+    return($this->options['filter']);
+  }
+
+
+  /**
+   * set to true to add a root item named 'all the gallery'
+   * id for this item will be equal to 0
+   *
+   * @param Bool $galleryRoot :
+   * @return Bool :
+   */
+  public function setGalleryRoot($galleryRoot)
+  {
+    if(is_bool($galleryRoot)) $this->options['galleryRoot']=$galleryRoot;
+    return($this->options['galleryRoot']);
+  }
+
+
+  /**
+   * get if a root item named 'all the gallery' is present or not
+   *
+   * @return Bool :
+   */
+  public function getGalleryRoot()
+  {
+    return($this->options['galleryRoot']);
+  }
+
+
+  /**
+   * get if the result have to be returned as a tree or as a flat array
+   *
+   * @return Bool :
+   */
+  public function getTree()
+  {
+    return($this->options['tree']);
+  }
+
+
+  /**
+   * set if the result have to be returned as a tree or as a flat array
+   *
+   * @param Bool $tree :
+   * @return Bool :
+   */
+  public function setTree($tree)
+  {
+    if(is_bool($tree)) $this->options['tree']=$tree;
+    return($this->options['tree']);
+  }
+
+
+
+
+  /**
+   * returns the user mode currently applied
+   *
+   * @return String :
+   */
+  public function getUserMode()
+  {
+    return($this->options['userMode']);
+  }
+
+
+  /**
+   * set the user mode to apply
+   *
+   * @param String $userMode :
+   * @return String :
+   */
+  public function setUserMode($userMode)
+  {
+    if($userMode==self::USER_MODE_ADMIN || $userMode==self::USER_MODE_PUBLIC) $this->options['userMode']=$userMode;
+
+    if($this->options['userMode']==self::USER_MODE_PUBLIC and
+       !($this->options['filter']==self::FILTER_ACCESSIBLE or $this->options['filter']==self::FILTER_PUBLIC)) $this->options['filter']==self::FILTER_ACCESSIBLE;
+    return($this->options['userMode']);
+  }
+
+
+
+  /**
+   * build an ordered category list
+   * returns an array, each item is an array like :
+   *  'id'     => the category Id
+   *  'name'   => the category name
+   *  'level'  => the category level
+   *  'status' => the category status (0='private', 1='public')
+   *  'childs' => the category have childs ? (true or false in flat mode, childs
+   *                in tree mode)
+   *
+   * @return Array : the list
+   */
+  public function getCategoryList()
+  {
+    global $user;
+
+    $returned=array();
+
+    if($this->options['galleryRoot'])
+    {
+      $startLevel=1;
+    }
+    else
+    {
+      $startLevel=0;
+    }
+
+    $sql="SELECT DISTINCT pct.id, pct.name, pct.global_rank AS rank, pct.status
+          FROM (".CATEGORIES_TABLE." pct ";
+
+    if($this->options['userMode']==self::USER_MODE_PUBLIC)
+    {
+      $sql.=" JOIN ".USER_CACHE_CATEGORIES_TABLE." pucc
+                ON (pucc.cat_id = pct.id) AND pucc.user_id='".$user['id']."') ";
+    }
+    else
+    {
+      $sql.=") ";
+    }
+
+    switch($this->options['filter'])
+    {
+      case self::FILTER_PUBLIC :
+        $sql.=" WHERE pct.status = 'public' ";
+        break;
+      case self::FILTER_ACCESSIBLE :
+        $sql.=" JOIN (
+                  SELECT DISTINCT pgat.cat_id AS catId FROM ".GROUP_ACCESS_TABLE." pgat
+                  UNION DISTINCT
+                  SELECT DISTINCT puat.cat_id AS catId FROM ".USER_ACCESS_TABLE." puat
+                     ) pat
+                ON (pat.catId = pct.id AND pct.status = 'private') OR (pct.status = 'public') ";
+        break;
+    }
+    $sql.="ORDER BY global_rank;";
+
+    $result=pwg_query($sql);
+    if($result)
+    {
+      while($row=pwg_db_fetch_assoc($result))
+      {
+        $row['level']=$startLevel+substr_count($row['rank'], '.');
+
+        /* rank is in formated without leading zero, giving bad order
+         *  1
+         *  1.10
+         *  1.11
+         *  1.2
+         *  1.3
+         *  ....
+         *
+         *  this loop cp,vert all sub rank in four 0 format, allowing to order
+         *  categories easily
+         *  0001
+         *  0001.0010
+         *  0001.0011
+         *  0001.0002
+         *  0001.0003
+         */
+        $row['rank']=explode('.', $row['rank']);
+        foreach($row['rank'] as $key=>$rank)
+        {
+          $row['rank'][$key]=str_pad($rank, 4, '0', STR_PAD_LEFT);
+        }
+        $row['rank']=implode('.', $row['rank']);
+
+        $returned[]=$row;
+      }
+    }
+
+    if($this->options['galleryRoot'])
+    {
+      $returned[]=array(
+        'id'     => 0,
+        'name'   => l10n('All the gallery'),
+        'rank'   => '0000',
+        'level'  => 0,
+        'status' => 'public',
+        'childs'  => null
+      );
+    }
+
+    usort($returned, array(&$this, 'compareCat'));
+
+    if($this->options['tree'])
+    {
+      $index=0;
+      $returned=$this->buildSubLevel($returned, $index);
+    }
+    else
+    {
+      //check if cats have childs & remove rank (enlight the response)
+      $prevLevel=-1;
+      for($i=count($returned)-1;$i>=0;$i--)
+      {
+        unset($returned[$i]['rank']);
+        if($returned[$i]['status']=='private')
+        {
+          $returned[$i]['status']='0';
+        }
+        else
+        {
+          $returned[$i]['status']='1';
+        }
+
+        if($returned[$i]['level']>=$prevLevel)
+        {
+          $returned[$i]['childs']=false;
+        }
+        else
+        {
+          $returned[$i]['childs']=true;
+        }
+        $prevLevel=$returned[$i]['level'];
+      }
+    }
+
+    return($returned);
+  }
+
+  /**
+   * used for sort comparison
+   * defined as public, but don't use it directly
+   *
+   * this function compare two categorie with their rank value
+   */
+  public function compareCat($catA, $catB)
+  {
+    if($catA['rank'] == $catB['rank'])
+    {
+      return(0);
+    }
+    return( ($catA['rank'] < $catB['rank'])?-1:1 );
+  }
+
+
+  /**
+   * used to convert a flat array in a leveled array
+   */
+  private function buildSubLevel(&$list, &$currentIndex)
+  {
+    $returned=array();
+
+    $localIndex=$currentIndex;
+    $list[$localIndex]['childs']=array();
+    // reduce size of returned data
+    unset($list[$currentIndex]['rank']);
+    if($list[$currentIndex]['status']=='private')
+    {
+      $list[$currentIndex]['status']='0';
+    }
+    else
+    {
+      $list[$currentIndex]['status']='1';
+    }
+    $currentIndex++;
+
+
+    while($currentIndex<count($list))
+    {
+      if($list[$currentIndex]['level']>$list[$localIndex]['level'])
+      {
+        $list[$localIndex]['childs']=$this->buildSubLevel($list, $currentIndex);
+      }
+      else if($list[$currentIndex]['level']==$list[$localIndex]['level'])
+      {
+        $returned[]=$list[$localIndex];
+
+        $localIndex=$currentIndex;
+        $list[$currentIndex]['childs']=array();
+
+        // reduce size of returned data
+        unset($list[$currentIndex]['rank']);
+        if($list[$currentIndex]['status']=='private')
+        {
+          $list[$currentIndex]['status']='0';
+        }
+        else
+        {
+          $list[$currentIndex]['status']='1';
+        }
+
+        $currentIndex++;
+      }
+      else
+      {
+        $returned[]=$list[$localIndex];
+        return($returned);
+      }
+    }
+    $returned[]=$list[$localIndex];
+
+    return($returned);
+  }
+
+}
+/*
+
+*/
Index: /extensions/GrumPluginClasses/classes/GPCCore.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCCore.class.inc.php	(revision 7174)
+++ /extensions/GrumPluginClasses/classes/GPCCore.class.inc.php	(revision 7175)
@@ -3,6 +3,6 @@
 /* -----------------------------------------------------------------------------
   class name     : GPCCore
-  class version  : 1.2.0
-  plugin version : 3.2.0
+  class version  : 1.3.0
+  plugin version : 3.3.0
   date           : 2010-07-28
   ------------------------------------------------------------------------------
@@ -20,5 +20,5 @@
 | 1.2.0   | 2010/07/28 | * add the loadConfigFromFile function
 |         |            |
-|         |            |
+| 1.3.0   | 2010/10/13 | * add the addHeaderCSS, addHeaderJS functions
 |         |            |
 |         |            |
@@ -35,4 +35,6 @@
     - static function unregister
     - static function BBtoHTML
+    - static function addHeaderCSS
+    - static function addHeaderJS
    ---------------------------------------------------------------------- */
 
@@ -42,4 +44,8 @@
 {
   static public $pluginName = "GPCCore";
+  static protected $headerItems = array(
+    'css' => array(),
+    'js'  => array()
+  );
 
   /* ---------------------------------------------------------------------------
@@ -305,5 +311,51 @@
   }
 
+  /**
+   * used to add a css file in the header
+   *
+   * @param String $id : a unique id for the file
+   * @param String $file : the css file
+   */
+  static public function addHeaderCSS($id, $file)
+  {
+    if(!array_key_exists($file, self::$headerItems['css']))
+    {
+      self::$headerItems['css'][$id]=$file;
+    }
+  }
+  static public function addHeaderJS($id, $file)
+  {
+    global $template;
+
+    if(!array_key_exists($id,  $template->known_scripts) and !array_key_exists($file, self::$headerItems['js']))
+    {
+     $template->known_scripts[$id]=$url;
+     self::$headerItems['js'][$id]=$file;
+    }
+  }
+
+  /**
+   * declared as public to be accessible by the event manager, but this funcion
+   * is not aimed to be used directly
+   */
+  static public function applyHeaderItems()
+  {
+    global $template;
+
+    foreach(self::$headerItems['css'] as $file)
+    {
+      $template->block_html_head(null, '<link rel="stylesheet" type="text/css" href="'.$file.'"/>', $template->smarty, $false);
+    }
+
+    foreach(self::$headerItems['js'] as $file)
+    {
+      $template->block_html_head(null, '<script type="text/javascript" src="'.$file.'"></script>', $template->smarty, $false);
+    }
+  }
+
 } //class
 
+add_event_handler('loc_end_page_header', array('GPCCore', 'applyHeaderItems'));
+
+
 ?>
Index: /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php
===================================================================
--- /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php	(revision 7174)
+++ /extensions/GrumPluginClasses/classes/GPCRequestBuilder.class.inc.php	(revision 7175)
@@ -466,5 +466,5 @@
     $template->append('head_elements', '<script type="text/javascript" src="plugins/'.$baseName.'external/interface/interface.js"></script>');
     $template->append('head_elements', '<script type="text/javascript" src="plugins/'.$baseName.'external/inestedsortable.pack.js"></script>');
-    $template->append('head_elements', '<script type="text/javascript" src="plugins/'.$baseName.'criteriaBuilder.js"></script>');
+    $template->append('head_elements', '<script type="text/javascript" src="plugins/'.$baseName.'criteriaBuilder.packed.js"></script>');
     $template->append('head_elements',
 "<script type=\"text/javascript\">
Index: /extensions/GrumPluginClasses/gpc_ajax.php
===================================================================
--- /extensions/GrumPluginClasses/gpc_ajax.php	(revision 7174)
+++ /extensions/GrumPluginClasses/gpc_ajax.php	(revision 7175)
@@ -16,4 +16,9 @@
  *
  * manage all the ajax requests
+ *
+ * known functions :
+ *  - admin.rbuilder.fillCaddie
+ *  - admin.categorySelector.getList
+ *
  * -----------------------------------------------------------------------------
  */
@@ -68,5 +73,7 @@
       // check if asked function is valid
       if(!(
-           $_REQUEST['ajaxfct']=='admin.rbuilder.fillCaddie'
+           $_REQUEST['ajaxfct']=='admin.rbuilder.fillCaddie' or
+           $_REQUEST['ajaxfct']=='admin.categorySelector.getList' or
+           $_REQUEST['ajaxfct']=='public.categorySelector.getList'
           )
         ) $_REQUEST['ajaxfct']='';
@@ -77,5 +84,5 @@
       {
         /*
-         * check admin.makeStats.getList values
+         * check admin.rbuilder.fillCaddie values
          */
         if($_REQUEST['ajaxfct']=="admin.rbuilder.fillCaddie")
@@ -88,6 +95,34 @@
           if(!isset($_REQUEST['requestNumber'])) $_REQUEST['ajaxfct']="";
         }
+
+        /*
+         * check admin.categorySelector.getList values
+         */
+        if($_REQUEST['ajaxfct']=="admin.categorySelector.getList" or
+           $_REQUEST['ajaxfct']=="public.categorySelector.getList")
+        {
+          if(!isset($_REQUEST['filter'])) $_REQUEST['filter']="accessible";
+
+          if(!($_REQUEST['filter']=="public" or
+               $_REQUEST['filter']=="accessible" or
+               $_REQUEST['filter']=="all")
+            ) $_REQUEST['filter']="accessible";
+
+          if(!isset($_REQUEST['galleryRoot'])) $_REQUEST['galleryRoot']="y";
+
+          if(!($_REQUEST['galleryRoot']=="y" or
+               $_REQUEST['galleryRoot']=="n")
+            ) $_REQUEST['galleryRoot']="y";
+
+          if(!isset($_REQUEST['tree'])) $_REQUEST['tree']="n";
+
+          if(!($_REQUEST['tree']=="y" or
+               $_REQUEST['tree']=="n")
+            ) $_REQUEST['tree']="n";
+        }
+
+
       }
-    }
+    } //checkRequest()
 
 
@@ -102,4 +137,10 @@
         case 'admin.rbuilder.fillCaddie':
           $result=$this->ajax_gpc_admin_rbuilderFillCaddie($_REQUEST['fillMode'], $_REQUEST['requestNumber']);
+          break;
+        case 'admin.categorySelector.getList':
+          $result=$this->ajax_gpc_admin_CategorySelectorGetList($_REQUEST['filter'], $_REQUEST['galleryRoot'], $_REQUEST['tree']);
+          break;
+        case 'public.categorySelector.getList':
+          $result=$this->ajax_gpc_public_CategorySelectorGetList($_REQUEST['filter'], $_REQUEST['galleryRoot'], $_REQUEST['tree']);
           break;
       }
@@ -141,4 +182,84 @@
     }
 
+
+
+    /**
+     * return the list of all categories
+     *
+     * @param String $filter : 'public' or 'accessible' or 'all'
+     * @param String $galleryRoot : 'y' if the gallery root is in the list
+     * @param String $tree : 'y' to obtain a recursive array, 'n' to obtain a flat array
+     * @return String : json string
+     */
+    private function ajax_gpc_admin_CategorySelectorGetList($filter, $galleryRoot, $tree)
+    {
+      global $user;
+
+      include_once(PHPWG_PLUGINS_PATH.'GrumPluginClasses/classes/GPCCategorySelector.class.inc.php');
+
+      $categorySelector=new GPCCategorySelector(
+        array(
+          'filter' => $filter,
+          'galleryRoot' => ($galleryRoot=='y')?true:false,
+          'tree' => ($tree=='y')?true:false,
+          'userMode' => 'admin'
+        )
+      );
+
+      $returned=array(
+        'userId' => $user['id'],
+        'nbCategories' => 0,
+        'categories' => $categorySelector->getCategoryList(),
+        'status' => array(
+          0=>l10n('Private'),
+          1=>l10n('Public')
+        )
+      );
+      $returned['nbCategories']=count($returned['categories']);
+
+      return(json_encode($returned));
+    } //ajax_gpc_admin_CategorySelectorGetList
+
+
+    /**
+     * return the list of all categories
+     *
+     * @param String $filter : 'public' or 'accessible' or 'all'
+     * @param String $galleryRoot : 'y' if the gallery root is in the list
+     * @param String $tree : 'y' to obtain a recursive array, 'n' to obtain a flat array
+     * @param String $userMode : 'public' or 'admin'
+     * @return String : json string
+     */
+    private function ajax_gpc_public_CategorySelectorGetList($filter, $galleryRoot, $tree)
+    {
+      global $user;
+
+      include_once(PHPWG_PLUGINS_PATH.'GrumPluginClasses/classes/GPCCategorySelector.class.inc.php');
+
+      $categorySelector=new GPCCategorySelector(
+        array(
+          'filter' => $filter,
+          'galleryRoot' => ($galleryRoot=='y')?true:false,
+          'tree' => ($tree=='y')?true:false,
+          'userMode' => 'public'
+        )
+      );
+
+      $returned=array(
+        'userId' => $user['id'],
+        'nbCategories' => 0,
+        'categories' => $categorySelector->getCategoryList(),
+        'status' => array(
+          0=>l10n('Private'),
+          1=>l10n('Public')
+        )
+      );
+      $returned['nbCategories']=count($returned['categories']);
+
+      return(json_encode($returned));
+    } //ajax_gpc_public_CategorySelectorGetList
+
+
+
   } //class
 
Index: /extensions/GrumPluginClasses/js/criteriaBuilder.js
===================================================================
--- /extensions/GrumPluginClasses/js/criteriaBuilder.js	(revision 7174)
+++ /extensions/GrumPluginClasses/js/criteriaBuilder.js	(revision 7175)
@@ -69,35 +69,32 @@
 {
   var itemsId = {
-    group:'iCbGroup',
-    item:'iCbItem',
-    container:container,
-  }
-
-  var counters = {
-    group:0,
-    item:0,
-  }
-
-  var options = {
-      textAND:'AND',
-      textOR:'OR',
-      textHint:'',
-      classGroup:'',
-      classItem:'',
-      classOperator:'',
-      classHelper:'helper',
-      opacity:0.8,
-      onEdit:null,
-      onDelete:null,
-      onRequestSuccess:null,
-      onRequestError:null,
-      onGetPageSuccess:null,
-      onGetPageError:null,
-      imgEditUrl:'',
-      imgDeleteUrl:'',
-      ajaxUrl:'',
-    };
-
-  var extraData = new Array();
+          group:'iCbGroup',
+          item:'iCbItem',
+          container:container,
+        },
+      counters = {
+          group:0,
+          item:0,
+        },
+      options = {
+          textAND:'AND',
+          textOR:'OR',
+          textHint:'',
+          classGroup:'',
+          classItem:'',
+          classOperator:'',
+          classHelper:'helper',
+          opacity:0.8,
+          onEdit:null,
+          onDelete:null,
+          onRequestSuccess:null,
+          onRequestError:null,
+          onGetPageSuccess:null,
+          onGetPageError:null,
+          imgEditUrl:'',
+          imgDeleteUrl:'',
+          ajaxUrl:'',
+        },
+      extraData = new Array();
 
   if(arguments.length==2)
@@ -213,5 +210,5 @@
         break;
     }
-  }
+  };
 
   /**
@@ -243,5 +240,5 @@
 
     applyNested();
-  }
+  };
 
   /**
@@ -253,5 +250,5 @@
   {
     $('#'+groupId).remove();
-  }
+  };
 
   /**
@@ -292,5 +289,5 @@
 
     extraData[counters.item]=data;
-  }
+  };
 
   /**
@@ -309,5 +306,5 @@
       manage();
     }
-  }
+  };
 
   /**
@@ -327,5 +324,5 @@
       extraData[eval(re.exec(itemId)[0])]=data;
     }
-  }
+  };
 
   /**
@@ -339,5 +336,5 @@
     counters.group=0;
     extraData=new Array();
-  }
+  };
 
   /**
@@ -370,5 +367,5 @@
     }
     return(returned);
-  }
+  };
 
 
@@ -410,5 +407,5 @@
 
     return(serialized);
-  }
+  };
 
 
@@ -423,5 +420,5 @@
 
     return(extraData[extraDataNumber]);
-  }
+  };
 
 
@@ -433,5 +430,5 @@
   {
     options = jQuery.extend(options, optionsToSet);
-  }
+  };
 
   /**
@@ -465,5 +462,5 @@
       }
     }
-  }
+  };
 
   /**
@@ -505,5 +502,5 @@
       }
     );
-  }
+  };
 
   /**
@@ -531,5 +528,5 @@
       }
     );
-  }
+  };
 
   /**
@@ -554,5 +551,5 @@
       $('#'+groupId+'OpOR').css('display', 'none');
     }
-  }
+  };
 
   /**
@@ -580,5 +577,5 @@
      );
 
-  }
+  };
 
   /**
@@ -606,5 +603,5 @@
      );
 
-  }
+  };
 
   applyNested();
Index: /extensions/GrumPluginClasses/js/pagesNavigator.js
===================================================================
--- /extensions/GrumPluginClasses/js/pagesNavigator.js	(revision 7174)
+++ /extensions/GrumPluginClasses/js/pagesNavigator.js	(revision 7175)
@@ -56,39 +56,37 @@
 {
   var itemsId = {
-    first:'iNavFirst',
-    last:'iNavLast',
-    previous:'iNavPrevious',
-    next:'iNavNext',
-    pageNumber:'iNavPage',
-    morePrevious:'iNavPrevMore',
-    moreNext:'iNavNextMore',
-    container:container,
-  };
-
-  var pages = {
-    num:0,
-    current:1,
-  }
-
-  var options = {
-    numberItem:0,
-    itemPerPage:25,
-    defaultPage:0,
-    displayNumPage:7,
-    displayFirst:true,
-    displayLast:true,
-    displayPrevious:true,
-    displayNext:true,
-    hideMode:'1,<', // "1": hide nav if only 1 page to display, "<": hide nav First, Previous, Next & Last if num of page < displayNumPage
-    textFirst:'&lt;&lt;',
-    textLast:'&gt;&gt;',
-    textPrevious:'&lt;',
-    textNext:'&gt;',
-    textMore:'...',
-    onPageChange:null,
-    classActive:'',
-    classInactive:'',
-    classDisabled:'',
-  };
+          first:'iNavFirst',
+          last:'iNavLast',
+          previous:'iNavPrevious',
+          next:'iNavNext',
+          pageNumber:'iNavPage',
+          morePrevious:'iNavPrevMore',
+          moreNext:'iNavNextMore',
+          container:container,
+        },
+      pages = {
+          num:0,
+          current:1,
+        },
+      options = {
+        numberItem:0,
+        itemPerPage:25,
+        defaultPage:0,
+        displayNumPage:7,
+        displayFirst:true,
+        displayLast:true,
+        displayPrevious:true,
+        displayNext:true,
+        hideMode:'1,<', // "1": hide nav if only 1 page to display, "<": hide nav First, Previous, Next & Last if num of page < displayNumPage
+        textFirst:'&lt;&lt;',
+        textLast:'&gt;&gt;',
+        textPrevious:'&lt;',
+        textNext:'&gt;',
+        textMore:'...',
+        onPageChange:null,
+        classActive:'',
+        classInactive:'',
+        classDisabled:'',
+      };
 
 
@@ -110,5 +108,5 @@
         break;
     }
-  }
+  };
 
   /**
@@ -122,5 +120,5 @@
   {
     return(Math.ceil(numItems/numPerPage));
-  }
+  };
 
   /**
@@ -143,5 +141,5 @@
       build();
     }
-  }
+  };
 
   /**
@@ -195,5 +193,5 @@
 
     $('#'+itemsId.container).css('visibility', 'visible');
-  }
+  };
 
 
@@ -206,5 +204,6 @@
       prev=pages.current-1;
     }
-    next=options.displayNumPage-1-prev
+    next=options.displayNumPage-1-prev;
+
     if(pages.current+next>=pages.num)
     {
@@ -283,5 +282,5 @@
     );
 
-  }
+  };
 
 
@@ -325,5 +324,5 @@
     displayNav();
     if(options.onPageChange!=null && jQuery.isFunction(options.onPageChange)) options.onPageChange(pages.current);
-  }
+  };
 
   if(arguments.length==2)
Index: /extensions/GrumPluginClasses/js/simpleTip.js
===================================================================
--- /extensions/GrumPluginClasses/js/simpleTip.js	(revision 7174)
+++ /extensions/GrumPluginClasses/js/simpleTip.js	(revision 7175)
@@ -81,9 +81,9 @@
 function simpleTip()
 {
-  var items = new Array();
-  var itemIndexInc = 0;
-  var options={
-    name:'',
-  }
+  var items = new Array(),
+      itemIndexInc = 0,
+      options={
+          name:'',
+        };
 
   if(arguments.length>=1)
@@ -134,5 +134,5 @@
         break;
     }
-  }
+  };
 
   var add = function (item, options)
@@ -169,5 +169,5 @@
     }
 
-  }
+  };
 
 
@@ -191,5 +191,5 @@
       items.splice(index,1);
     }
-  }
+  };
 
 
@@ -216,5 +216,5 @@
     }
     itemIndexInc=0;
-  }
+  };
 
 
@@ -228,5 +228,5 @@
     }
     return(-1);
-  }
+  };
 
   /**
@@ -255,5 +255,5 @@
           display: 'block',
         }
-      )
+      );
 
     switch(items[itemIndex].options.targetPos)
@@ -415,15 +415,15 @@
       .addClass(items[itemIndex].options.classes);
 
-  }
+  };
 
   var show = function ()
   {
     $('#iSimpleTip'+options.name).css('display', 'block');
-  }
+  };
 
   var hide = function ()
   {
     $('#iSimpleTip'+options.name).css('display', 'none');
-  }
+  };
 
 
@@ -435,5 +435,5 @@
       $('body').append(text);
     }
-  }
+  };
 
 
